Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label1 As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(8, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(392, 32)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "Left-click at least two points. Then right-click to begin. Click again to stop."
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(408, 357)
        Me.Controls.Add(Me.Label1)
        Me.Name = "Form1"
        Me.Text = "howto_net_sierpinski_gasket_2"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private m_Running As Boolean
    Private m_NumPoints As Integer
    Private m_CornerX() As Integer
    Private m_CornerY() As Integer

    Private Const RADIUS As Integer = 5

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Randomize()
    End Sub

    Private Sub Form1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        If m_Running Then
            ' Stop running.
            m_Running = False
            m_NumPoints = 0
        Else
            ' Left or right button?
            If e.Button = MouseButtons.Left Then
                ' If this is the first point,
                ' erase the previous picture.
                Dim gr As Graphics = Me.CreateGraphics()
                If m_NumPoints = 0 Then gr.Clear(Me.BackColor)

                ' Save the point.
                m_NumPoints = m_NumPoints + 1
                ReDim Preserve m_CornerX(m_NumPoints - 1)
                ReDim Preserve m_CornerY(m_NumPoints - 1)
                m_CornerX(m_NumPoints - 1) = e.X
                m_CornerY(m_NumPoints - 1) = e.Y
                gr.DrawEllipse(Pens.Blue, e.X - RADIUS \ 2, e.Y - RADIUS \ 2, RADIUS, RADIUS)
            Else
                ' See if we have enough points.
                If m_NumPoints < 2 Then
                    ' We need more points.
                    MsgBox("You must left-click at least two points before right-clicking.", _
                        vbExclamation, "Need More Points")
                Else
                    ' Start.
                    m_Running = True
                    PlotPoints()
                End If
            End If
        End If
    End Sub

    Private Sub PlotPoints()
        Dim i As Integer
        Dim last_x As Single
        Dim last_y As Single

        ' Pick a starting point.
        i = CInt(Int(Rnd() * m_NumPoints))
        last_x = m_CornerX(i)
        last_y = m_CornerY(i)

        ' Plot points until the user clicks again.
        Dim gr As Graphics = Me.CreateGraphics()
        Do While m_Running
            ' Pick the next corner.
            i = CInt(Int(Rnd() * m_NumPoints))

            ' Move halfway from the current point
            ' to the new corner.
            last_x = (last_x + m_CornerX(i)) / 2
            last_y = (last_y + m_CornerY(i)) / 2

            gr.DrawLine(Pens.Red, last_x, last_y, last_x + 1, last_y + 1)

            ' Check for events.
            Application.DoEvents()
        Loop
    End Sub

    Private Sub Form1_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        End
    End Sub
End Class
